/* 
	Description:
		ZK Essentials
	History:
		Created by dennis

Copyright (C) 2012 Potix Corporation. All Rights Reserved.
*/
package my.ais.domain;

import java.io.Serializable;
import java.util.Date;
/**
 * User entity
 */
public class User_ori implements Serializable,Cloneable {
	private static final long serialVersionUID = 1L;
	String account;
	String fullName;
	String password;
	String email;
	Date birthday;
	String country;
	String bio;

	public User_ori(String account, String password, String fullName,String email) {
		this.account = account;
		this.password = password;
		this.fullName = fullName;
		this.email = email;
	}

	public String getAccount() {
		return account;
	}

	public String getFullName() {
		return fullName;
	}

	public void setFullName(String fullName) {
		this.fullName = fullName;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Date getBirthday() {
		return birthday;
	}

	public void setBirthday(Date birthday) {
		this.birthday = birthday;
	}

	public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	public String getBio() {
		return bio;
	}

	public void setBio(String bio) {
		this.bio = bio;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((account == null) ? 0 : account.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		User_ori other = (User_ori) obj;
		if (account == null) {
			if (other.account != null)
				return false;
		} else if (!account.equals(other.account))
			return false;
		return true;
	}
	
	public static User_ori clone(User_ori user){
		try {
			return (User_ori)user.clone();
		} catch (CloneNotSupportedException e) {
			//not possible
		}
		return null;
	}
}
